/***************************************
 * Created by Junyi Tang.
 *
 * 2009.1.14 
 *
 * GPL v2
 * */


#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <error.h>

#include <gtk/gtk.h>

#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>

#define WIDTH		500
#define HEIGHT		WIDTH * 0.618
#define BUFFER_SIZE	4096

char head_code[64];
char tail_code[64];

char result[BUFFER_SIZE];
int result_flag = -1;

char *lang_array_head[] = {"英语", "简体中文", "法语"};
char *lang_array_tail[] = {"简体中文", "英语", "法语"};

char *lang_array_head_encode[] = {"en", "zh-CN", "fr"};
char *lang_array_tail_encode[] = {"zh-CN", "en", "fr"};

GtkWidget *text_view_input;
GtkWidget *text_view_output;
GtkTextBuffer *textbuffer_input;
GtkTextBuffer *textbuffer_output;
GtkTextIter iter, start, end;

//回调函数
size_t write_data (void *ptr, size_t size, size_t nmemb, void *stream)	
{
  FILE *fp;	//定义FILE类型指针
  int written;
  
  if(0 == (get_content((char *)ptr)) )
	  result_flag = 1;

  fp = fopen("/dev/null", "w");
  written = fwrite (ptr, size, nmemb, (FILE *) fp);
  fclose(fp);

  return written;
}

//解析返回的html页面，获取翻译结果
int get_content(char *html_content)
{
  char *ss_start = NULL;
  char *se_end = NULL;

  char *ss = "<div id=result_box dir=\"ltr\">";
  char *se = "</div>";

  ss_start = strstr(html_content, ss);
  
  if(ss_start != NULL)
  {
  	se_end = strstr(ss_start, se);
	ss_start += strlen(ss);
	strncat(result, ss_start, se_end - ss_start); 
  	return 0;
  }

  return -1;

}

/*
//编码输入的单词序列
int encodeText(char translateText[])
{
    int i;

    for(i=0; i<strlen(translateText); i++)
    {
    	if(translateText[i] == ' ' || translateText[i] == '\n' || translateText[i] == '\t' || translateText[i] == '\r')
	{
		translateText[i] = '+';
	}
    }

    return 0;
}
*/

/************************************************
 * 把字符串进行URL编码。
 * 输入：
 * str: 要编码的字符串
 * strSize: 字符串的长度。这样str中可以是二进制数据
 * result: 结果缓冲区的地址
 * resultSize:结果地址的缓冲区大小(如果str所有字符都编码，该值为strSize*3)
 * 返回值：
 * >0: result中实际有效的字符长度，
 * 0: 编码失败，原因是结果缓冲区result的长度太小
 ***********************************************/ 
int URLEncode(const char* str, const int strSize, char* result, const int resultSize) 
{
	int i;
	int j = 0; /* for result index */
	char ch;

	if ((str == NULL) || (result == NULL) || (strSize <= 0) || (resultSize <= 0)) {
		return 0;
	}

	for (i=0; (i<strSize) && (j<resultSize); i++) {
		ch = str[i];
		if ((ch >= 'A') && (ch <= 'Z')) {
			result[j++] = ch;
		} else if ((ch >= 'a') && (ch <= 'z')) {
			result[j++] = ch;
		} else if ((ch >= '0') && (ch <= '9')) {
			result[j++] = ch;
		} else if(ch == ' ' || ch == '\n' || ch == '\r'|| ch == '\t'){
			result[j++] = '+';
		} else {
			if (j + 3 < resultSize) {
				sprintf(result+j, "%%%02X", (unsigned char)ch);
				j += 3;
			} else {
				return 0;
			}
		}
	}

	result[j] = '\0';
	return j;
} 

//向服务器发送请求
int translate_engine(char *inputText)
{
  char urlstr[BUFFER_SIZE];
  char langpair[256];
  char engineUrl[256];
  CURL *curl;
  
  memset(urlstr, 0, BUFFER_SIZE);
	
  int inputTextLen = sizeof(char) * 3 * strlen(inputText);
  char *inputText_encoded = malloc(inputTextLen);
  
  sprintf(langpair, "%s|%s", head_code, tail_code);
  sprintf(engineUrl, "%s", "http://translate.google.cn/translate_t");
  //sprintf(engineUrl, "%s", "http://translate.google.com/translate_t");

  URLEncode(inputText, strlen(inputText), inputText_encoded, inputTextLen + 2);
  sprintf(urlstr, "%s?text=%s&langpair=%s", engineUrl, inputText_encoded, langpair);
  //sprintf(urlstr, "%s?hl=%s#%s|%s", engineUrl, head_code, langpair, inputText_encoded);

  fprintf(stdout, "urlstr: %s\n", urlstr);

  curl_global_init (CURL_GLOBAL_ALL);
  curl = curl_easy_init ();
#ifdef _DEBUG
  curl_easy_setopt(curl, CURLOPT_VERBOSE, 1);
#endif
  curl_easy_setopt (curl, CURLOPT_URL, urlstr);
  curl_easy_setopt (curl, CURLOPT_WRITEFUNCTION, write_data);	
  curl_easy_perform (curl);
  curl_easy_cleanup (curl);

  return 0;
}

//将获取的最终结果显示在界面上
void print_text(GtkWidget *widget, gpointer data)
{
	char *inputText;

	textbuffer_input = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view_input));
	gtk_text_buffer_get_bounds(textbuffer_input, &start, &end);
	inputText = gtk_text_buffer_get_text(textbuffer_input, &start, &end, -1);

	translate_engine(inputText);
	int utf8_text_len = strlen(result);
	char *utf8_text = malloc(utf8_text_len);
	
  	if(strcmp(head_code, "zh-CN"))
	{
		utf8_text = g_convert(result, -1, "utf-8", "GB2312", NULL, NULL, NULL);
	}
	else
		sprintf(utf8_text, "%s", result);
	gtk_text_buffer_set_text(textbuffer_output, utf8_text, -1);
	memset(result, 0, BUFFER_SIZE);
}

//清除输入内容
void clean_text(GtkWidget *widget, gpointer data)
{
	textbuffer_input = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view_input));
	gtk_text_buffer_set_text(textbuffer_input, "", -1);
}

//选择需要翻译的语言种类
void on_changed_head(GtkWidget *w, gpointer data)
{
	int i = gtk_combo_box_get_active(GTK_COMBO_BOX(w));
	sprintf(head_code, "%s", lang_array_head_encode[i]);
}

//选择翻译出的语言种类
void on_changed_tail(GtkWidget *w, gpointer data)
{
	int i = gtk_combo_box_get_active(GTK_COMBO_BOX(w));
	sprintf(tail_code , "%s", lang_array_tail_encode[i]);
}

//主函数
int main(int argc,char *argv[])
{
	GtkWidget *window;
	GtkWidget *button_ok;
	GtkWidget *button_clean;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *scroll1;
	GtkWidget *scroll2;

	GtkWidget *combo_head;
	GtkWidget *combo_tail;
	GtkWidget *label;
	GList *glist_head = NULL;
	GList *glist_tail = NULL;
	 
	gtk_init(&argc, &argv);
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_size_request(window, WIDTH, HEIGHT);
	g_signal_connect(GTK_OBJECT(window),"destroy",G_CALLBACK(gtk_main_quit),NULL);
	
	vbox = gtk_vbox_new (FALSE, 0);

	scroll1 = gtk_scrolled_window_new(NULL, NULL); 
	scroll2 = gtk_scrolled_window_new(NULL, NULL); 

	text_view_input = gtk_text_view_new();//创建文本框构件
	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(text_view_input), GTK_WRAP_WORD_CHAR);

	text_view_output = gtk_text_view_new();/*创建文本框构件*/
	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(text_view_output), GTK_WRAP_WORD_CHAR);

	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll1), text_view_input);
	gtk_box_pack_start(GTK_BOX (vbox), scroll1, TRUE, TRUE, 5);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll2), text_view_output);
	gtk_box_pack_start(GTK_BOX (vbox), scroll2, TRUE, TRUE, 5);

	//获得文本框缓冲区
	textbuffer_output = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view_output));
	gtk_text_buffer_get_iter_at_offset(textbuffer_output, &iter, 0);
	
	hbox = gtk_hbox_new(FALSE, 0);

	button_clean = gtk_button_new_with_label("清除");
	gtk_box_pack_start (GTK_BOX (hbox), button_clean, FALSE, FALSE, 3);
	gtk_signal_connect(GTK_OBJECT(button_clean), "clicked", G_CALLBACK(clean_text), NULL); 

	button_ok = gtk_button_new_with_label("确定");
	gtk_box_pack_start (GTK_BOX (hbox), button_ok, FALSE, FALSE, 3);
	gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", G_CALLBACK(print_text), NULL); 

	combo_head = gtk_combo_box_new_text();
	combo_tail = gtk_combo_box_new_text();

	int i;

	for(i=0; i<3; i++) 
	{
		gtk_combo_box_append_text(GTK_COMBO_BOX(combo_head), lang_array_head[i]);
	}

	for(i=0; i<3; i++) 
	{
		gtk_combo_box_append_text(GTK_COMBO_BOX(combo_tail), lang_array_tail[i]);
	}
	
	sprintf(head_code, "%s", "en");
	sprintf(tail_code, "%s", "zh-CN");

	/*
	glist_head = g_list_append(glist_head,"英语");
	glist_head = g_list_append(glist_head,"简体中文");
	glist_head = g_list_append(glist_head,"繁体中文");

	glist_tail = g_list_append(glist_tail,"简体中文");
	glist_tail = g_list_append(glist_tail,"英语");
	glist_tail = g_list_append(glist_tail,"繁体中文");
	*/

	//gtk_combo_set_popdown_strings(GTK_COMBO(combo_head), glist_head);
	//gtk_combo_set_popdown_strings(GTK_COMBO(combo_tail), glist_tail);

	gtk_combo_box_set_active (GTK_COMBO_BOX(combo_head), 0);
	gtk_combo_box_set_active (GTK_COMBO_BOX(combo_tail), 0);
	g_signal_connect (combo_head, "changed", G_CALLBACK (on_changed_head), NULL);
	g_signal_connect (combo_tail, "changed", G_CALLBACK (on_changed_tail), NULL);

	label = gtk_label_new (" >> ");

	gtk_box_pack_start (GTK_BOX (hbox), combo_head, TRUE, TRUE, 3);
	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 3);
	gtk_box_pack_start (GTK_BOX (hbox), combo_tail, TRUE, TRUE, 3);
	
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 3);

	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show_all(window);
	gtk_main();

	return 0;
}
